//
// ConInheritance.cpp
//
// LECTURE 11
// DEMO 5
//
#include "StdAfx.h"

#include <iostream>
#include <string>
using namespace std;  //introduces namespace std

#include "Person.h"

// So that the compiler won't give us a warning...
void printPersonInfo(Person &);

// Here's the Student class (derived)
class Student: public Person
{
public:
  Student(string Name,string Addr,string Phone,int id):
  	  Person(Name,Addr,Phone),
      studentID(id)
    {
      cout << "Hello from Student Constructor" << endl;
    }
  void printInfo();
  int  getId() { return studentID; }
  void printClassification();
private:
  int  studentID;
};


void Student::printInfo()
{
  Person::printInfo();  // WHAT ARE YOU DOING HERE, RON?
  cout << "Student ID: " << studentID << endl;
}

void Student::printClassification()
{
  cout << "CLASSIFICATION:  STUDENT" << endl;
}


void printPersonInfo(Person &aPerson)
{
  aPerson.printInfo();
  aPerson.printClassification();
}


int main()
{	
  Student aStudent("Joe Student","166 Phelps Lane","555-1212",1234);
 
  // Question of the day:  Can you call a constructor yourself?
  //Student s2 = aStudent.Student("Ron","123","555-3333",1235);
   
  // Now set the information.  Remember, setInfo() is 
  // defined in the "Person" class
  cout << "First, the student..." << endl;
  printPersonInfo(aStudent);
  //printPersonInfo(s2);
  return 0;

}

